'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = withQueryParams;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _reactDisplayName = require('react-display-name');

var _reactDisplayName2 = _interopRequireDefault(_reactDisplayName);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withQueryParams() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      keys = _ref.keys,
      _ref$stripUnknownKeys = _ref.stripUnknownKeys,
      stripUnknownKeys = _ref$stripUnknownKeys === undefined ? false : _ref$stripUnknownKeys,
      queryStringOptions = _ref.queryStringOptions;

  if (keys && stripUnknownKeys) {
    (0, _utils.assert)((0, _keys2.default)(keys).length > 0, 'at least one query param key must be configured');
  }

  if (keys) {
    (0, _keys2.default)(keys).forEach(function (key) {
      (0, _utils.assert)(keys[key].default, 'Missing default value for key ' + key);
      (0, _utils.assert)(typeof keys[key].default === 'string' || typeof keys[key].default === 'function', '\'default\' for key ' + key + ' must be a string or a function');
      (0, _utils.assert)(keys[key].validate, 'Missing validate function for key ' + key);
      (0, _utils.assert)(typeof keys[key].validate === 'function', '\'validate\' for ' + key + ' must be a function');
    });
  }

  var QUERYPARAMS_OPTIONS = (0, _extends4.default)({
    arrayFormat: 'none' }, queryStringOptions);

  return function (Wrapped) {
    var WithQueryParams = function (_PureComponent) {
      (0, _inherits3.default)(WithQueryParams, _PureComponent);

      function WithQueryParams() {
        var _ref2;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, WithQueryParams);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = WithQueryParams.__proto__ || (0, _getPrototypeOf2.default)(WithQueryParams)).call.apply(_ref2, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(WithQueryParams, [{
        key: 'render',
        value: function render() {
          var _this2 = this;

          var location = this.props.location;

          var queryParams = _queryString2.default.parse(location.search, QUERYPARAMS_OPTIONS);

          var newQueryParams = keys ? (0, _keys2.default)(keys).reduce(function (acc, paramName) {
            var defaultConf = keys[paramName].default;
            var defaultValue = typeof defaultConf === 'function' ? defaultConf(queryParams[paramName], _this2.props) : defaultConf;

            return (0, _extends4.default)({}, acc, (0, _defineProperty3.default)({}, paramName, keys[paramName].validate(queryParams[paramName], _this2.props) ? queryParams[paramName] : defaultValue));
          }, {}) : queryParams;

          var allParams = stripUnknownKeys ? newQueryParams : (0, _extends4.default)({}, queryParams, newQueryParams);

          var searchString = _queryString2.default.stringify(allParams, QUERYPARAMS_OPTIONS);

          if (location.search.replace('?', '') !== searchString) {
            return _react2.default.createElement(_reactRouterDom.Redirect, { to: { pathname: location.pathname, search: searchString } });
          }

          var wrappedProps = {
            location: location,
            setQueryParam: this.setQueryParam,
            queryParams: allParams
          };

          return _react2.default.createElement(Wrapped, (0, _extends4.default)({}, this.props, wrappedProps));
        }
      }]);
      return WithQueryParams;
    }(_react.PureComponent);

    WithQueryParams.displayName = 'withQueryParams(' + (0, _reactDisplayName2.default)(Wrapped) + ')';
    WithQueryParams.propTypes = {
      location: _propTypes2.default.shape({
        search: _propTypes2.default.string,
        pathname: _propTypes2.default.string
      }).isRequired,
      history: _propTypes2.default.shape({
        push: _propTypes2.default.func.isRequired,
        createHref: _propTypes2.default.func.isRequired
      }).isRequired
    };

    var _initialiseProps = function _initialiseProps() {
      var _this3 = this;

      this.setQueryParam = function () {
        var obj = (0, _utils.isObject)(arguments.length <= 0 ? undefined : arguments[0]) ? arguments.length <= 0 ? undefined : arguments[0] : (0, _defineProperty3.default)({}, arguments.length <= 0 ? undefined : arguments[0], arguments.length <= 1 ? undefined : arguments[1]);

        _this3.setQueryParams(obj);
      };

      this.setQueryParams = function (obj) {
        var _props = _this3.props,
            location = _props.location,
            history = _props.history;


        var to = history.createHref({
          pathname: location.pathname,
          search: _queryString2.default.stringify((0, _extends4.default)({}, _queryString2.default.parse(location.search, QUERYPARAMS_OPTIONS), obj), QUERYPARAMS_OPTIONS)
        });

        history.push(to);
      };
    };

    return (0, _reactRouterDom.withRouter)(WithQueryParams);
  };
}